<?php
/**
 * Generating module
 *
 * @version        $Id: module_make.php 1 14:17 2010年7月20日Z tianya $
 * @package        DedeCMS.Administrator
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */
@set_time_limit(0);
require_once(dirname(__FILE__)."/config.php");
require_once(dirname(__FILE__)."/../include/dedemodule.class.php");
CheckPurview('sys_module');
if(empty($action)) $action = '';

if($action=='')
{
    $modules = array();
    require_once(dirname(__FILE__)."/templets/module_make.htm");
    exit();
}
/*---------
//Get the Hash code
function GetHash()
----------*/
else if($action=='gethash')
{
    echo md5($modulname.$email);
    exit();
}
/*-------------
//Generating project
function Makemodule()
--------------*/
else if($action=='make')
{
    $filelist = str_replace("\r", "\n", trim($filelist));
    $filelist = trim(preg_replace("#[\n]{1,}#", "\n", $filelist));
    if($filelist=='')
    {
        ShowMsg("Sorry, you didn't specify the list of files for the module, so you can't create the project!","-1");
        exit();
    }

    //Get rid of the escape
    foreach($_POST as $k=>$v) $$k = stripslashes($v);

    if(!isset($autosetup)) $autosetup = 0;
    if(!isset($autodel)) $autodel = 0;
    $mdir = DEDEDATA.'/module';
    $hashcode = md5($modulname.$email);
    $moduleFilename = $mdir.'/'.$hashcode.'.xml';
    $menustring = base64_encode($menustring);
    $indexurl = str_replace('=', '**', $indexurl);
    $dm = new DedeModule($mdir);

    if($dm->HasModule($hashcode))
    {
        $dm->Clear();
        ShowMsg("Sorry, you specify that the module of the same name already exists, so you cannot create the project!<br>If you want to update this module, please delete it first:module/{$hashcode}.xml","-1");
        exit();
    }

    $readmef = $setupf = $uninstallf = '';

    if(empty($readmetxt))
    {
        move_uploaded_file($readme, $mdir."/{$hashcode}-r.html") or die("You didn't fill in the instructions or upload the instructions!");
        $readmef = $dm->GetEncodeFile($mdir."/{$hashcode}-r.html", TRUE);
    }
    else
    {
        $readmetxt = "<p style='line-height:150%'>".$readmetxt;
        $readmetxt = preg_replace("#[\r\n]{1,}#", "<br />\r\n", $readmetxt);
        $readmetxt .= "</p>";
        $readmef = base64_encode(trim($readmetxt));
    }
    
    if($autosetup==0)
    {
        move_uploaded_file($setup,$mdir."/{$hashcode}-s.php") or die("You didn't upload or the system couldn't move the setup file to the module directory!");
        $setupf = $dm->GetEncodeFile($mdir."/{$hashcode}-s.php",TRUE);
    }

    if($autodel==0)
    {
        move_uploaded_file($uninstall, $mdir."/{$hashcode}-u.php") or die("You have not uploaded, or the system cannot move uninstall files to the module directory!");
        $uninstallf = $dm->GetEncodeFile($mdir."/{$hashcode}-u.php", TRUE);
    }

    if(trim($setupsql40)=='') $setupsql40 = '';
    else $setupsql40 = base64_encode(trim($setupsql40));

    //if(trim($setupsql41)=='') $setupsql41 = '';
    //else $setupsql41 = base64_encode(trim($setupsql41));

    if(trim($delsql)=='') $delsql = '';
    else $delsql = base64_encode(trim($delsql));

    $modulinfo = "<module>
<baseinfo>
name={$modulname}
team={$team}
time={$mtime}
email={$email}
url={$url}
hash={$hashcode}
indexname={$indexname}
indexurl={$indexurl}
ismember={$ismember}
autosetup={$autosetup}
autodel={$autodel}
lang={$lang}
moduletype={$moduletype}
</baseinfo>
<systemfile>
<menustring>
$menustring
</menustring>
<readme>
{$readmef}
</readme>
<setupsql40>
$setupsql40
</setupsql40>
<delsql>
$delsql
</delsql>
<setup>
{$setupf}
</setup>
<uninstall>
{$uninstallf}
</uninstall>
<oldfilelist>
$filelist
</oldfilelist>
</systemfile>
";

    $filelists = explode("\n", $filelist);
    foreach($filelists as $v)
    {
      $v = trim($v);
      if(!empty($v)) $dm->MakeEncodeFileTest(dirname(__FILE__), $v);
    }
    //Compile the installation package after the test is correct
    $fp = fopen($moduleFilename, 'w');
    fwrite($fp, $modulinfo);
    fwrite($fp, "<modulefiles>\r\n");
    foreach($filelists as $v)
    {
      $v = trim($v);
      if(!empty($v)) $dm->MakeEncodeFile(dirname(__FILE__), $v, $fp);
    }
    fwrite($fp, "</modulefiles>\r\n");
    fwrite($fp, "</module>\r\n");
    fclose($fp);
    ShowMsg("Successfully compile a new module!", "module_main.php");
    exit();
}
/*-------------
//Modify the project
function editModule()
--------------*/
else if($action=='edit')
{
    $filelist = str_replace("\r", "\n", trim($filelist));
    $filelist = trim(preg_replace("#[\n]{1,}#", "\n", $filelist));
    if($filelist=="")
    {
        ShowMsg("Sorry, you didn't specify the list of files for the module, so you can't create the project!","-1");
        exit();
    }

    //It has been removed
    foreach($_POST as $k=>$v) $$k = stripslashes($v);
    if(!isset($autosetup)) $autosetup = 0;
    if(!isset($autodel)) $autodel = 0;
    $mdir = DEDEDATA.'/module';
    $hashcode = $hash;
    $moduleFilename = $mdir.'/'.$hashcode.'.xml';
    $modulname = str_replace('=', '', $modulname);
    $email = str_replace('=', '', $email);
    $team = str_replace('=', '', $team);
    $indexurl = str_replace('=', '**', $indexurl);
    $menustring = base64_encode($menustring);
    $dm = new DedeModule($mdir);
    $readmef = base64_encode($readmetxt);
    $setupf = $uninstallf = '';
    
    //Compile the setup file
    if(is_uploaded_file($setup)) 
    {
        move_uploaded_file($setup, $mdir."/{$hashcode}-s.php") or die("You didn't upload or the system couldn't move the setup file to the module directory!");
        $setupf = $dm->GetEncodeFile($mdir."/{$hashcode}-s.php", TRUE);
    } else {
        if($autosetup==0) $setupf = base64_encode($dm->GetSystemFile($hashcode, 'setup'));
    }

     //Compile the uninstall file
    if(is_uploaded_file($uninstall)) 
    {
        move_uploaded_file($uninstall,$mdir."/{$hashcode}-u.php") or die("You have not uploaded, or the system cannot move uninstall files to the module directory!");
        $uninstallf = $dm->GetEncodeFile($mdir."/{$hashcode}-u.php",true);
    } else {
        if($autodel==0) $uninstallf = base64_encode($dm->GetSystemFile($hashcode,'uninstall'));
    }

    if(trim($setupsql40)=='') $setupsql40 = '';
    else $setupsql40 = base64_encode(htmlspecialchars_decode(trim($setupsql40)));
    //if(trim($setupsql41)=='') $setupsql41 = '';
    //else $setupsql41 = base64_encode(trim($setupsql41));

    if(trim($delsql)=='') $delsql = '';
    else $delsql = base64_encode(strip_tags(trim($delsql)));

    $modulinfo = "<module>
<baseinfo>
name={$modulname}
team={$team}
time={$mtime}
email={$email}
url={$url}
hash={$hashcode}
indexname={$indexname}
indexurl={$indexurl}
ismember={$ismember}
autosetup={$autosetup}
autodel={$autodel}
lang={$lang}
moduletype={$moduletype}
</baseinfo>
<systemfile>
<menustring>
$menustring
</menustring>
<readme>
{$readmef}
</readme>
<setupsql40>
$setupsql40
</setupsql40>
<delsql>
$delsql
</delsql>
<setup>
{$setupf}
</setup>
<uninstall>
{$uninstallf}
</uninstall>
<oldfilelist>
$filelist
</oldfilelist>
</systemfile>
";

    if($rebuild=='yes')
    {
        $filelists = explode("\n", $filelist);
        foreach($filelists as $v)
        {
          $v = trim($v);
          if(!empty($v)) $dm->MakeEncodeFileTest(dirname(__FILE__),$v);
        }
        //Compile the installation package after the test is correct
        $fp = fopen($moduleFilename, 'w');
        fwrite($fp, $modulinfo."\r\n");
        fwrite($fp, "<modulefiles>\r\n");
        foreach($filelists as $v)
        {
            $v = trim($v);
            if(!empty($v)) $dm->MakeEncodeFile(dirname(__FILE__),$v,$fp);
        }
        fwrite($fp,"</modulefiles>\r\n");
        fwrite($fp,"</module>\r\n");
        fclose($fp);
    } else {
        $fxml = $dm->GetFileXml($hashcode);
        $fp = fopen($moduleFilename, 'w');
        fwrite($fp, $modulinfo."\r\n");
        fwrite($fp, $fxml);
        fclose($fp);
    }
    ShowMsg("Successfully recompile the module!", "module_main.php");
    exit();
}
//ClearAllLink();
