<?php
/**
 * Payment interface
 *
 * @version        $Id: sys_info_mark.php 1 22:28 July 20, 2010Z tianya $
 * @package        DedeCMS.Administrator
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */
require_once(dirname(__FILE__)."/config.php");
require_once(DEDEINC.'/datalistcp.class.php');
CheckPurview('sys_Data');

$dopost = (empty($dopost))? '' : $dopost;
$pid = (empty($pid))? 0 : preg_replace('/[^0-9]/','',$pid);
/*
The following is an example of a group format:
*/
//A simple [array <-> form] parsing class
/*The array structure should be:
  array(
    [name]=>array(
        [title]=>'The name of the current form item',
        [type]=>'text|select',
        [description]=>'Introduction to form content'
        [iterm]=>'1:Use the standard double interface and use the secured trading interface', //If they contain":",I'm going to call it value,The following is the display content
        [value]=>'Use the secured trading interface',
    ),
    ...
  )
  Usage:
The above format is passed into an array and then resolved:
Declare the class and create an array
  $af = new Array2form($config);
  
  2. Set a form template (optional, if not set to default)
  $af->SetDefaultTpl($templets); $templets:File for a primer template
  Form template format:
  <p>~title~:~form~<small>~description~</small></p>
  
  3.Get a specific project form
  $af->GetIterm('alipay', 1) //1. To obtain a complete form under a default template. 2. To retrieve only one form item
  
  4.Get all the form content
  $af->GetAll() //Gets all the parsing of the form
  
*/
class Array2form
{
    var $FormArray = array();
    var $ArrFromTPL = '';
    
    function __construct($formarray = array())
    {
        if(count($formarray) > 1)
        {
            $this->FormArray = $formarray;
          //var_dump($this->FormArray);
            $this->SetDefaultTpl();
        }
    }
    
    //Destructor, compatible with PHP4
    /*
    function Array2form($formarray = array())
    {
        $this->__construct($formarray);
    }
    */
    
    //Get a form for a specific project
    function GetIterm($itermid = '', $itermtype = 1)
    {
        $reval = $reval_form =  $reval_title = $reval_des = $myformItem = '';
        if(is_array($this->FormArray))
        {
            foreach ($this->FormArray as $key => $val) {
                if($key == $itermid)
                {
                    $reval_title = $val['title'];
                    $reval_des = $val['description'];
                    $reval_form = $this->GetForm($key,$val, $val['type']);
                    //Make a template tag substitution
                    if($itermtype == 1)
                        $reval = preg_replace(array("/~title~/","/~form~/","/~description~/"), 
                                                                array($reval_title, $reval_form, $reval_des), $this->ArrFromTPL);
                    else return $reval_form;    
                }
            }
        } else {
            return FALSE;
        }
        return empty($reval)? '' : $reval;    
    }
    
    function GetForm($key, $formarry = array(), $formtype='text')
    {
        switch ($formtype) 
        {
            case 'text':
                //Generate a text edit box
                $valstr=(empty($formarry['value']))? "value=''" : "value='{$formarry['value']}'";
                $reval_form = "<input type='text' name='{$key}' id='{$key}' style='width:300px' class='text'{$valstr}>";
            break;
            case 'select':
                //Generate select box
                $reval_title = $formarry['title'];
                $items = explode(',',$formarry['iterm']);
                $reval_form = "<select name='{$key}' class='text'>";
                if(is_array($items))
                {
                    foreach($items as $v)
                    {
                        $v = trim($v);
                        if($v=='') continue;
                        //Unify the Chinese colon into English
                        $v = str_replace("：", ":", $v);
                        if( preg_match("/[\:]/",$v) )
                        { 
                            list($value, $name) = preg_split('#:#', $v);
                            $reval_form .= ($formarry['value'] == $value)? "<option value='$value' selected>$name</option>\r\n" : "<option value='$value'>$name</option>\r\n";
                        } else {
                            $reval_form .= ($formarry['value'] == $v)? "<option value='$v' selected>$v</option>\r\n" : "<option value='$v'>$v</option>\r\n";
                        }
                    }
                }
                $reval_form .= "</select>\r\n";
            break;
        }
        return $reval_form;
    }
    
    
    //Get all the form content
    function GetAll()
    {
        $reval=empty($reval)? '' : $reval;    
        if(is_array($this->FormArray))
        {
            foreach ($this->FormArray as $key => $val)
            {
                $reval .= $this->GetIterm($key);
            }
            return $reval;
        }else{
            return FALSE;    
        }
    }
    
    //Get all the form content
    function SetDefaultTpl($tplname = '')
    {
        if(empty($tplname)) 
        {
            $this->ArrFromTPL = '<p>~title~：~form~<small>~description~</small></p>';
        } else {
            if(file_exists($tplname)) $this->ArrFromTPL = file_get_contents($tplname);
          else $this->ArrFromTPL = $tplname;
        }
    }
}
$tplstring = "
            <tr>
              <td height='25' align='center'>~title~：</td>
              <td>~form~ <small>~description~</small></td>
            </tr>
";

//Install payment interface
if($dopost=='install')
{
    $row = $dsql->GetOne("SELECT * FROM `#@__payment` WHERE id='$pid'");
    if(is_array($row))
    {
        if($cfg_soft_lang == 'utf-8')
        {
            $config_row = AutoCharset(unserialize(utf82gb($row['config'])));
        }else if($cfg_soft_lang == 'gb2312'){
            $config_row = unserialize($row['config']);
        }
        //print_r($config_row);exit;
        $af = new Array2form($config_row);
        $af->SetDefaultTpl($tplstring);
        $reval = $af->GetAll();
    }
    include DedeInclude('templets/sys_payment_install.htm');
    exit;
} 
//Configure payment interface
else if($dopost=='config')
{
    if($pay_name=="" || $pay_desc=="" || $pay_fee=="")
    {
        ShowMsg("You have unfilled projects!","-1");
        exit();
    }
    $row = $dsql->GetOne("SELECT * FROM `#@__payment` WHERE id='$pid'");
    if($cfg_soft_lang == 'utf-8')
    {
        $config = AutoCharset(unserialize(utf82gb($row['config'])));
    }else if($cfg_soft_lang == 'gb2312'){
        $config = unserialize($row['config']);
    }
    $payments = "'code' => '".$row['code']."',";
    foreach ($config as $key => $v)
    {
        $config[$key]['value'] = ${$key};
        $payments .= "'".$key."' => '".$config[$key]['value']."',";
    }
    $payments = substr($payments, 0, -1);
    $payment = "\$payment=array(".$payments.")";
    $configstr = "<"."?php\r\n".$payment."\r\n?".">\r\n";
    if(!empty($payment))
    {
        $m_file = DEDEDATA."/payment/".$row['code'].".php";
        $fp = fopen($m_file,"w") or die("Written to the file $safeconfigfile Fail, please check permissions!");
        fwrite($fp,$configstr);
        fclose($fp);
    }
    if($cfg_soft_lang == 'utf-8')
    {
        $config = AutoCharset($config,'utf-8','gb2312');
        $config = serialize($config);
        $config = gb2utf8($config);
    }else{
        $config = serialize($config);
    }
    
    $query = "UPDATE `#@__payment` SET name = '$pay_name',fee='$pay_fee',description='$pay_desc',config='$config',enabled='1' WHERE id='$pid'";
    $dsql->ExecuteNoneQuery($query);
    if($pm=='edit') $msg="Save the modified success";
    else $msg="Install successfully!";
    ShowMsg($msg, "sys_payment.php");
    exit();
}

//Delete payment interface
else if($dopost=='uninstall')
{
    $row = $dsql->GetOne("SELECT * FROM `#@__payment` WHERE id='$pid'");
    if($cfg_soft_lang == 'utf-8')
    {
        $config = AutoCharset(unserialize(utf82gb($row['config'])));
    }else if($cfg_soft_lang == 'gb2312'){
        $config = unserialize($row['config']);
    }
    foreach ($config as $key => $v) $config[$key]['value']="";
    if($cfg_soft_lang == 'utf-8')
    {
        $config = AutoCharset($config,'utf-8','gb2312');
        $config = serialize($config);
        $config = gb2utf8($config);
    }else{
        $config = serialize($config);
    }
    $query = "UPDATE `#@__payment` SET fee='',config='$config',enabled='0' WHERE id='$pid'";
    $dsql->ExecuteNoneQuery($query);
    //You also need to remove the corresponding cache
    $m_file = DEDEDATA."/payment/".$row['code'].".php";
    @unlink($m_file);
    ShowMsg("Delete success!", "sys_payment.php");
    exit();
}
$sql = "SELECT * FROM `#@__payment` ORDER BY rank ASC";
$dlist = new DataListCP();
$dlist->SetTemplet(DEDEADMIN."/templets/sys_payment.htm");
$dlist->SetSource($sql);
$dlist->display();