<?php
require_once(dirname(__FILE__)."/config.php");
require_once(dirname(__FILE__)."/../image.func.php");

require_once(dirname(__FILE__)."/../json.class.php");

 
$php_path = dirname(__FILE__) . '/';
$php_url = dirname($_SERVER['PHP_SELF']) . '/';

//Root directory path, you can specify the absolute path, for example /var/www/attached/
$root_path = $php_path . '../../uploads/';
//Root URL, you can specify the absolute path, for example http://www.yoursite.com/attached/
$root_url = $php_url . '../../uploads/';
//Image extension
$ext_arr = array('gif', 'jpg', 'jpeg', 'png', 'bmp');


//According to the path parameter, set the path and URL
if (empty($_GET['path'])) {
	$current_path = realpath($root_path) . '/';
	$current_url = $root_url;
	$current_dir_path = '';
	$moveup_dir_path = '';
} else {
	$current_path = realpath($root_path) . '/' . $_GET['path'];
	$current_url = $root_url . $_GET['path'];
	$current_dir_path = $_GET['path'];
	$moveup_dir_path = preg_replace('/(.*?)[^\/]+\/$/', '$1', $current_dir_path);
}
echo realpath($root_path);
//Sort form，name or size or type
$order = empty($_GET['order']) ? 'name' : strtolower($_GET['order']);

//Not allowed to use .. Move to a higher level directory
if (preg_match('/\.\./', $current_path)) {
	echo 'Access is not allowed.';
	exit;
}
//The last character is not/
if (!preg_match('/\/$/', $current_path)) {
	echo 'Parameter is not valid.';
	exit;
}
//The directory does not exist or is not a directory
if (!file_exists($current_path) || !is_dir($current_path)) {
	echo 'Directory does not exist.';
	exit;
}

//Traverse the directory to obtain the file information
$file_list = array();
if ($handle = opendir($current_path)) {
	$i = 0;
	while (false !== ($filename = readdir($handle))) {
		if ($filename{0} == '.') continue;
		$file = $current_path . $filename;
		if (is_dir($file)) {
			$file_list[$i]['is_dir'] = true; //Whether the folder
			$file_list[$i]['has_file'] = (count(scandir($file)) > 2); //Whether the folder contains files
			$file_list[$i]['filesize'] = 0; //File size
			$file_list[$i]['is_photo'] = false; //Whether the picture
			$file_list[$i]['filetype'] = ''; //File type, with extension to judge
		} else {
			$file_list[$i]['is_dir'] = false;
			$file_list[$i]['has_file'] = false;
			$file_list[$i]['filesize'] = filesize($file);
			$file_list[$i]['dir_path'] = '';
			$file_ext = strtolower(array_pop(explode('.', trim($file))));
			$file_list[$i]['is_photo'] = in_array($file_ext, $ext_arr);
			$file_list[$i]['filetype'] = $file_ext;
		}
		$file_list[$i]['filename'] = $filename; //File name, including extension
		$file_list[$i]['datetime'] = date('Y-m-d H:i:s', filemtime($file)); //Last modified file time
		$i++;
	}
	closedir($handle);
}

//Sort
function cmp_func($a, $b) {
	global $order;
	if ($a['is_dir'] && !$b['is_dir']) {
		return -1;
	} else if (!$a['is_dir'] && $b['is_dir']) {
		return 1;
	} else {
		if ($order == 'size') {
			if ($a['filesize'] > $b['filesize']) {
				return 1;
			} else if ($a['filesize'] < $b['filesize']) {
				return -1;
			} else {
				return 0;
			}
		} else if ($order == 'type') {
			return strcmp($a['filetype'], $b['filetype']);
		} else {
			return strcmp($a['filename'], $b['filename']);
		}
	}
}
usort($file_list, 'cmp_func');

$result = array();
//Row relative to the root directory of a directory
$result['moveup_dir_path'] = $moveup_dir_path;
//The current directory relative to the root directory
$result['current_dir_path'] = $current_dir_path;
//The current directory URL
$result['current_url'] = $current_url;
//Number of documents
$result['total_count'] = count($file_list);
//File list array
$result['file_list'] = $file_list;

//Output JSON string
$json = new Services_JSON();
echo $json->encode($result);
?>
