<?php  if(!defined('DEDEINC')) exit('dedecms');
/**
 * Verify the assistant
 *
 * @version        $Id: validate.helper.php 2 13:56 2010-07-05  tianya $
 * @package        DedeCMS.Helpers
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */

/**
 * Browser-friendly variable output, easy to use when debugging
 *
 * @param     mixed   $var       To view the contents of the output
 * @param     bool    $echo      Whether the direct output
 * @param     string  $label     Add the description tag, if any, which shows "tag name:" this form
 * @param     bool    $strict    Is strictly filtered
 * @return    string
 */
if ( ! function_exists('Dump'))
{
    function Dump($var, $echo=true, $label=null, $strict=true)
    {
        $label = ($label===null) ? '' : rtrim($label) . ' ';
        if(!$strict) {
            if (ini_get('html_errors')) {
                $output = print_r($var, true);
                $output = "<pre>".$label.htmlspecialchars($output,ENT_QUOTES)."</pre>";
            } else {
                $output = $label . " : " . print_r($var, true);
            }
        }else {
            ob_start();
            var_dump($var);
            $output = ob_get_clean();
            if(!extension_loaded('xdebug')) {
                $output = preg_replace("/\]\=\>\n(\s+)/m", "] => ", $output);
                $output = '<pre>'. $label. htmlspecialchars($output, ENT_QUOTES). '</pre>';
            }
        }
        if ($echo) {
            echo($output);
            return null;
        }else
            return $output;
    }
}

/**
 *  Get the execution time
 *  E.g:$t1 = ExecTime();
 *      After a period of content processing:
 *       $t2 = ExecTime();
 *  We can output the difference between two times:echo $t2-$t1;
 *
 *  @return    int
 */
if ( ! function_exists('ExecTime'))
{
    function ExecTime()
    {
        $time = explode(" ", microtime());
        $usec = (double)$time[0];
        $sec = (double)$time[1];
        return $sec + $usec;
    }
}
