/**
 * @class _08cms.multiStore
 * @author Peace@08cms.com
 * @reference: http://www.cnblogs.com/zjcn/archive/2012/07/03/2575026.html#comboWrap
 * Demo: 
	_08cms.locStore.set('aa1','bb1');
	var tt1 = _08cms.locStore.get('aa1');
	console.log(tt1);
	_08cms.sesStore.set('aa2','bb2');
	var tt2 = _08cms.sesStore.get('aa2');
	console.log(tt2);
 */
 
// localStorage/sessionStorage Store public method properties =================================================

function multiStore(flag){ // local,session
	this.parFlag = flag=='session' ? 'sessionStorage' : 'localStorage';
	this.parStore = flag=='session' ? window.sessionStorage : window.localStorage;
	// Whether to support it localStorage/sessionStorage
	this.ready = function(){ 
		return (this.parFlag in window) && (window[this.parFlag] !== null); 
	};
	// Extended: up to save mnum key (such as recent browsing history)
	// demo: _08cms.locStore|sesStore.setGroup('{$ckpre}chid{$chid}','{aid}',10); // ('_auto_dev52_chid2','542350',10); 
	// ??? A record store more information? There is no deal with this, normative? At present to expand, such as similar information【id|529026;time|14-07-2110:50】
	this.setGroup = function(keyid,nowkey,mnum){
		if(nowkey.length==0) return;
		if(!mnum) mnum = 10;
		var oldkeys = this.get(keyid); 
		if(!oldkeys){ 
			var keystr = nowkey;
		}else{ 
			var oldarr = oldkeys.split(','); 
			var keystr = nowkey; unum = 1;
			for(var i=0;i<oldarr.length;i++){ 
				if(oldarr[i]==nowkey || oldarr[i].length==0) continue;
				if(unum<mnum){
					keystr += ','+oldarr[i];	
					unum++;
				}else{
					break;	
				}
			}
		}
		keystr = keystr.replace(/[^0-9A-Za-z_\.\-\:\,\|\;]/g,''); // setGroup Content character limit \=\)\(\]\[  Good use ascii code
		this.set(keyid,keystr);
	};
	// Extension: Initialize information(not support localStorage/sessionStorage)
	// demo: _08cms.locStore|sesStore.initMessage('itemList','<li class="none">not support localStorage/sessionStorage(Local storage)</li>')
	this.initMessage = function(id,msg){
		var canFlag = this.ready();
		if(!canFlag) document.getElementById(id).innerHTML = msg;
	};
	// Settings
	this.set = function(key, value){
		//Sometimes in the iPhone / iPad setItem () will appear strange QUOTA_EXCEEDED_ERR error; then generally before the setItem, removeItem () ok
		if( this.get(key) !== null )
			this.remove(key);
		this.parStore.setItem(key, value);
	};
	// Get the value of the query does not exist key, some browsers return undefined, here unified return null
	this.get = function(key){
		var v = this.parStore.getItem(key);
		return v === undefined ? null : v;
	};
	this.each = function(fn){
		var n = this.parStore.length, i = 0, fn = fn || function(){}, key;
		for(; i<n; i++){
			key = this.parStore.key(i);
			if( fn.call(this, key, this.get(key)) === false )
				break;
			//If the content is deleted, the total length and index are reduced simultaneously
			if( this.parStore.length < n ){
				n --;
				i --;
			}
		}
	};
	this.remove = function(key){
		this.parStore.removeItem(key);
	}
	this.clear = function(){
		this.parStore.clear();
	};
	
}

// localStorage/sessionStorage Into _08cms object =================================================

_08cms.locStore = new multiStore('local');
_08cms.sesStore = new multiStore('session');

// Expand =================================================

//function exStore(p1){
//	this.dosth = function (){ };
//}
//exStore.prototype = new mulStore('local');
//_08cms.exStore = new exStore('p');

