<?php
if(!defined('DEDEINC')) exit('Request Error!');
/**
 *Epro interface class
 */
class yeepay
{
    var $dsql;
    var $mid;
  
    # business type
    # Payment request, fixed value"Buy" 
    var $p0_Cmd = 'Buy';
  
    # delivery address
    # Is "1": Requires the user to leave the shipping address on Epro payment system; "0": not required, defaults to "0".
    var $p9_SAF = "0";
    
    # Gateway address can not be changed
    var $reqURL_onLine = "https://www.yeepay.com/app-merchant-proxy/node";
    //$reqURL_onLine = "http://tech.yeepay.com:8080/robot/debug.action";
    
    var $return_url='/plus/carbuyaction.php?dopost=return'; //Return processing address
        
    /**
    * Constructor
    *
    * @access  public
    * @param
    *
    * @return void
    */
    function yeepay()
    {
        global $dsql;
        $this->dsql = $dsql;
    }

    function __construct()
    {
        $this->yeepay();
    }
    
    /**
     *  Set the interface will send the address
     *
     *  E.g: $this->SetReturnUrl($cfg_basehost."/tuangou/control/index.php?ac=pay&orderid=".$p2_Order)
     *
     * @param     string  $returnurl  Will send address
     * @return    void
     */
    function SetReturnUrl($returnurl='')
    {
        if (!empty($returnurl))
        {
            $this->return_url = $returnurl;
        }
    }

    /**
    * Generate payment code
    * @param   array   $order      order information
    * @param   array   $payment    Payment method information
    */
    function GetCode($order, $payment)
    {
        global $cfg_basehost,$cfg_cmspath;
        //For the secondary directory processing
        if(!empty($cfg_cmspath)) $cfg_basehost = $cfg_basehost.'/'.$cfg_cmspath;

        #    The merchant sets payment information for the user's purchase of the product.
        ##Epro payment platform unified GBK / GB2312 encoding, parameters such as the use of Chinese, please note that transcoding
        
        #   Business order number, optional.
        ##If not, submit the order number must be unique in their own account transactions; for "", eBao payment will automatically generate a random business order number.
        $p2_Order                    = trim($order['out_trade_no']);
        
        #    Payment amount, required.
        ##Unit: yuan, accurate to points.
        $p3_Amt                        = $order['price'];
        
        #    Trading currency, fixed value"CNY".
        $p4_Cur                        = "CNY";
        
        #    product name
        ##Used to pay for the product information displayed on the left of the eBay payment gateway.
        $p5_Pid                        = trim($order['out_trade_no']);
        
        #    Types of goods
        $p6_Pcat                    = 'cart';
        
        #    product description
        $p7_Pdesc                    = '';
        
        #    The merchant receives the address of the payment success data, and after the payment is successful, Epro will send a success notification to the address twice.
        //$p8_Url                        = $cfg_basehost."/plus/carbuyaction.php?dopost=return&code=".$payment['code'];  
        $p8_Url                        =   $cfg_basehost.$this->return_url.'&code='.$payment['code'];
        
        #    Business expansion of information
        ##Merchants can fill in any 1K string, the payment will be returned as it is.                                                
        $pa_MP                        = 'member';
        
        #    Response mechanism
        ##Is "1": Requires answering mechanism; "0": No answering mechanism is required.
        $pr_NeedResponse    = 1;
        
        #    Bank code
            ##If you do not need to display the pages that Epro pays, you can directly go to the payment page of each bank, Shenzhouxing Bank, Jun Wang Card, etc. This field can be set according to the appendix: Bank List.            
        $pd_FrpId                    = '';
        #Call the signature function to generate a signature string
        $hmac = $this->getReqHmacString($payment['yp_account'],$payment['yp_key'],$p2_Order,$p3_Amt,$p4_Cur,$p5_Pid,$p6_Pcat,$p7_Pdesc,$p8_Url,$pa_MP,$pd_FrpId,$pr_NeedResponse);
        
        $button = '<form target="_blank" method="post" action="'.$this->reqURL_onLine.'">
                            <input type="hidden" value="'.$this->p0_Cmd.'" name="p0_Cmd">
                            <input type="hidden" value="'.$payment['yp_account'].'" name="p1_MerId">
                            <input type="hidden" value="'.$p2_Order.'" name="p2_Order">
                            <input type="hidden" value="'.$p3_Amt.'" name="p3_Amt">
                            <input type="hidden" value="'.$p4_Cur.'" name="p4_Cur">
                            <input type="hidden" value="'.$p5_Pid.'" name="p5_Pid">
                            <input type="hidden" value="'.$p6_Pcat.'" name="p6_Pcat">
                            <input type="hidden" value="'.$p7_Pdesc.'" name="p7_Pdesc">
                            <input type="hidden" value="'.$p8_Url.'" name="p8_Url">
                            <input type="hidden" value="'.$this->p9_SAF.'" name="p9_SAF">
                            <input type="hidden" value="'.$pa_MP.'" name="pa_MP">
                            <input type="hidden" value="'.$pd_FrpId.'" name="pd_FrpId">
                            <input type="hidden" value="'.$pr_NeedResponse.'" name="pr_NeedResponse"    >
                            <input type="hidden" value="'.$hmac.'" name="hmac">
                            <input type="submit" value="Pay with YeePay now"></form>';

    /* Empty the shopping cart */
        require_once DEDEINC.'/shopcar.class.php';
        $cart     = new MemberShops();
        $cart->clearItem();
        $cart->MakeOrders();
        return $button;
    }

    /**
    * Response operation
    */
    function respond()
    {

        /* Import the configuration file */
		$code = preg_replace( "#[^0-9a-z-]#i", "", $_REQUEST['code'] );
		require_once DEDEDATA.'/payment/'.$code.'.php';
        
        $p1_MerId = trim($payment['yp_account']);
        $merchantKey = trim($payment['yp_key']);
        
        #  Parse the return parameter.
        $return = $this->getCallBackValue($r0_Cmd, $r1_Code, $r2_TrxId, $r3_Amt, $r4_Cur, $r5_Pid, $r6_Order, $r7_Uid, $r8_MP, $r9_BType, $hmac);
        
        #  Determine whether the signature is correct（True/False）
        $bRet = $this->CheckHmac($p1_MerId,$merchantKey,$r0_Cmd,$r1_Code,$r2_TrxId,$r3_Amt,$r4_Cur,$r5_Pid,$r6_Order,$r7_Uid,$r8_MP,$r9_BType,$hmac);

        #  The verification code is correct.
        if($bRet)
        {
            if($r1_Code=="1")
            {
                /*Determine the order type*/
                if(preg_match ("/S-P[0-9]+RN[0-9]/",$r6_Order)) 
                {
                    //Get user mid
                    $row = $this->dsql->GetOne("SELECT * FROM #@__shops_orders WHERE oid = '{$r6_Order}'");
                    $this->mid = $row['userid'];
                    $ordertype="goods";
                } else if (preg_match ("/M[0-9]+T[0-9]+RN[0-9]/",$r6_Order)){
                    $row = $this->dsql->GetOne("SELECT * FROM #@__member_operation WHERE buyid = '{$r6_Order}'");
                    //Obtain order information and check the validity of the order
                    if(!is_array($row)||$row['sta']==2) return $msg = "Your order has been processed, please do not repeat it!";
                    $ordertype = "member";
                    $product =    $row['product'];
                    $pname= $row['pname'];
                    $pid=$row['pid'];
                    $this->mid = $row['mid'];
                } else {    
                    return $msg = "Payment failed, your order number is in question!";
                }


                #    Need to compare the amount returned with the merchant database in the amount of the order is equal, only the same case that the transaction was successful.
                #    And the need to deal with the return of the transaction control, recording the exclusive treatment, to prevent duplication of the same transaction occurred.              
                if($r9_BType == "1" || $r9_BType == "3"){
                    if($ordertype == "goods"){ 
                        if($this->success_db($r6_Order))  return $msg = "payment successful!<br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                        else  return $msg = "Payment failed!<br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                    } else if ($ordertype=="member") {
                        $oldinf = $this->success_mem($r6_Order,$pname,$product,$pid);
                        return $msg = "<font color='red'>".$oldinf."</font><br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                    }
                } else if ( $r9_BType == "2" ){
                    #If you need a reply mechanism, you must write back the stream, starting with success, case insensitive.
                    echo "success";
                    if($ordertype=="goods"){ 
                        if($this->success_db($r6_Order))  return $msg = "payment successful!<br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                        else  return $msg = "Payment failed!<br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                    } else if ($ordertype=="member") {
                        if($this->success_mem($r6_Order,$pname,$product,$pid))  return $msg = "payment successful!<br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                        else  return $msg = "Payment failed!<br> <a href='/'>return to home page</a> <a href='/member'>Member Centre</a>";
                    }
                }
            }
        } else {
            $this->log_result ("verify_failed");
            return $msg = "Transaction information is tampered with!<br> <a href='/'>return to home page</a> ";
        }
    }


    #Signature function generates a signature string
    function getReqHmacString($p1_MerId,$merchantKey,$p2_Order,$p3_Amt,$p4_Cur,$p5_Pid,$p6_Pcat,$p7_Pdesc,$p8_Url,$pa_MP,$pd_FrpId,$pr_NeedResponse)
    {
        #Signing process must be in accordance with the document marked in the order of signature
        $sbOld = "";
        #Add business type
        $sbOld = $sbOld.$this->p0_Cmd;
        #Add the business number
        $sbOld = $sbOld.$p1_MerId;
        #Add business order number
        $sbOld = $sbOld.$p2_Order;     
        #Join the payment amount
        $sbOld = $sbOld.$p3_Amt;
        #Add the transaction currency
        $sbOld = $sbOld.$p4_Cur;
        #Add the product name
        $sbOld = $sbOld.$p5_Pid;
        #Add to the product category
        $sbOld = $sbOld.$p6_Pcat;
        #Add product description
        $sbOld = $sbOld.$p7_Pdesc;
        #Add the address where the merchant receives the payment success data
        $sbOld = $sbOld.$p8_Url;
        #Add delivery address ID
        $sbOld = $sbOld.$this->p9_SAF;
        #Add business extension information
        $sbOld = $sbOld.$pa_MP;
        #Join the bank code
        $sbOld = $sbOld.$pd_FrpId;
        #Join Need to answer the mechanism
        $sbOld = $sbOld.$pr_NeedResponse;
        
        return $this->HmacMd5($sbOld,$merchantKey);
    } 

    #    Get back to the string of all the parameters
    function getCallBackValue(&$r0_Cmd,&$r1_Code,&$r2_TrxId,&$r3_Amt,&$r4_Cur,&$r5_Pid,&$r6_Order,&$r7_Uid,&$r8_MP,&$r9_BType,&$hmac)
    {  
        $r0_Cmd       = $_REQUEST['r0_Cmd'];
        $r1_Code      = $_REQUEST['r1_Code'];
        $r2_TrxId     = $_REQUEST['r2_TrxId'];
        $r3_Amt       = $_REQUEST['r3_Amt'];
        $r4_Cur       = $_REQUEST['r4_Cur'];
        $r5_Pid       = $_REQUEST['r5_Pid'];
        $r6_Order     = $_REQUEST['r6_Order'];
        $r7_Uid       = $_REQUEST['r7_Uid'];
        $r8_MP        = $_REQUEST['r8_MP'];
        $r9_BType     = $_REQUEST['r9_BType']; 
        $hmac         = $_REQUEST['hmac'];
        return NULL;
    }

    function CheckHmac($p1_MerId,$merchantKey,$r0_Cmd,$r1_Code,$r2_TrxId,$r3_Amt,$r4_Cur,$r5_Pid,$r6_Order,$r7_Uid,$r8_MP,$r9_BType,$hmac)
    {
        if($hmac == $this->getCallbackHmacString($p1_MerId,$merchantKey,$r0_Cmd,$r1_Code,$r2_TrxId,$r3_Amt,$r4_Cur,$r5_Pid,$r6_Order,$r7_Uid,$r8_MP,$r9_BType))
            return TRUE;
        else
            return FALSE;
    }

    function getCallbackHmacString($p1_MerId,$merchantKey,$r0_Cmd,$r1_Code,$r2_TrxId,$r3_Amt,$r4_Cur,$r5_Pid,$r6_Order,$r7_Uid,$r8_MP,$r9_BType)
    {
        #Obtain encrypted string
        $sbOld = "";
        #Add a business ID
        $sbOld = $sbOld.$p1_MerId;
        #Add message type
        $sbOld = $sbOld.$r0_Cmd;
        #Add business return code
        $sbOld = $sbOld.$r1_Code;
        #Add transaction ID
        $sbOld = $sbOld.$r2_TrxId;
        #Join the transaction amount
        $sbOld = $sbOld.$r3_Amt;
        #Add currency unit
        $sbOld = $sbOld.$r4_Cur;
        #Add product Id
        $sbOld = $sbOld.$r5_Pid;
        #Add order ID
        $sbOld = $sbOld.$r6_Order;
        #Add user ID
        $sbOld = $sbOld.$r7_Uid;
        #Add business extension information
        $sbOld = $sbOld.$r8_MP;
        #Add the transaction result return type
        $sbOld = $sbOld.$r9_BType;
        
        return $this->HmacMd5($sbOld,$merchantKey,'gbk');

    }

    function HmacMd5($data,$key,$lang='utf-8')
    {
        // RFC 2104 HMAC implementation for php.
        // Creates an md5 HMAC.
        // Eliminates the need to install mhash to compute a HMAC
        // Hacked by Lance Rushing(NOTE: Hacked means written)
        
        //You need to configure the environment to support iconv. Otherwise, the Chinese parameters can not be processed normally
        if($GLOBALS['cfg_soft_lang'] != 'utf-8' || $lang!='utf-8')
        {
            $key = gb2utf8($key);
            $data = gb2utf8($data);
        }
        $b = 64; // byte length for md5
        if (strlen($key) > $b) {
            $key = pack("H*",md5($key));
        }
        $key = str_pad($key, $b, chr(0x00));
        $ipad = str_pad('', $b, chr(0x36));
        $opad = str_pad('', $b, chr(0x5c));
        $k_ipad = $key ^ $ipad ;
        $k_opad = $key ^ $opad;
        
        return md5($k_opad . pack("H*",md5($k_ipad . $data)));
    }

    /*Deal with the goods*/
    function success_db($order_sn)
    {
        //Obtain order information and check the validity of the order
        $row = $this->dsql->GetOne("SELECT state FROM #@__shops_orders WHERE oid='$order_sn' ");
        if($row['state'] > 0)
        {
            return TRUE;
        }    
        /* Change order status_ payment successful */
        $sql = "UPDATE `#@__shops_orders` SET `state`='1' WHERE `oid`='$order_sn' AND `userid`='".$this->mid."'";
        if($this->dsql->ExecuteNoneQuery($sql))
        {
            $this->log_result("verify_success,order number:".$order_sn); //Save the verification results in a file
            return TRUE;
        } else {
            $this->log_result ("verify_failed,order number:".$order_sn);//Save the verification results in a file
            return FALSE;
        }
    }

    /*Processing point card, membership upgrade*/
    function success_mem($order_sn,$pname,$product,$pid)
    {
        //Update transaction status as paid
        $sql = "UPDATE `#@__member_operation` SET `sta`='1' WHERE `buyid`='$order_sn' AND `mid`='".$this->mid."'";
        $this->dsql->ExecuteNoneQuery($sql);

        /* Change order card status_ payment successful*/
        if($product=="card")
        {
            $row = $this->dsql->GetOne("SELECT cardid FROM #@__moneycard_record WHERE ctid='$pid' AND isexp='0' ");;
            //If you can not find some type of card, add coins directly to the user
            if(!is_array($row))
            {
                $nrow = $this->dsql->GetOne("SELECT num FROM #@__moneycard_type WHERE pname = '{$pname}'");
                $dnum = $nrow['num'];
                $sql1 = "UPDATE `#@__member` SET `money`=money+'{$nrow['num']}' WHERE `mid`='".$this->mid."'";
                $oldinf ="Has been recharged".$nrow['num']."Gold coins to your account！";
            } else {
                $cardid = $row['cardid'];
                $sql1=" UPDATE #@__moneycard_record SET uid='".$this->mid."',isexp='1',utime='".time()."' WHERE cardid='$cardid' ";
                $oldinf='Your recharge password is：<font color="green">'.$cardid.'</font>';
            }
            //Update transaction status is off
            $sql2=" UPDATE #@__member_operation SET sta=2,oldinfo='$oldinf' WHERE buyid='$order_sn'";
            if($this->dsql->ExecuteNoneQuery($sql1) && $this->dsql->ExecuteNoneQuery($sql2))
            {
                $this->log_result("verify_success,order number:".$order_sn); //Save the verification results in a file
                return $oldinf;
            } else {
                $this->log_result ("verify_failed,order number:".$order_sn);//Save the verification results in a file
                return "Payment failed!";
            }
        /* Change membership order status_ payment successful */
        } else if ( $product=="member" ){
            $row = $this->dsql->GetOne("SELECT rank,exptime FROM #@__member_type WHERE aid='$pid' ");
            $rank = $row['rank'];
            $exptime = $row['exptime'];
            /*Calculate the remaining days of the original upgrade*/
            $rs = $this->dsql->GetOne("SELECT uptime,exptime FROM #@__member WHERE mid='".$this->mid."'");
            if($rs['uptime']!=0 && $rs['exptime']!=0 ) 
            {
                $nowtime = time();
                $mhasDay = $rs['exptime'] - ceil(($nowtime - $rs['uptime'])/3600/24) + 1;
                $mhasDay=($mhasDay>0)? $mhasDay : 0;
            }
            //Get the default gold coins and points for members
            $memrank = $this->dsql->GetOne("SELECT money,scores FROM #@__arcrank WHERE rank='$rank'");
            //Update member information
            $sql1 =  " UPDATE #@__member SET rank='$rank',money=money+'{$memrank['money']}',
                       scores=scores+'{$memrank['scores']}',exptime='$exptime'+'$mhasDay',uptime='".time()."' 
                       WHERE mid='".$this->mid."'";
            //Update transaction status is off
            $sql2=" UPDATE #@__member_operation SET sta='2',oldinfo='Member upgraded successfully!' WHERE buyid='$order_sn' ";
            if($this->dsql->ExecuteNoneQuery($sql1) && $this->dsql->ExecuteNoneQuery($sql2))
            {
                $this->log_result("verify_success,order number:".$order_sn); //Save the verification results in a file
                return "Member upgraded successfully！";
            } else {
                $this->log_result ("verify_failed,order number:".$order_sn);//Save the verification results in a file
                return "Member upgrade failed！";
            }
        }    
    }

    function  log_result($word) {
        global $cfg_cmspath;
        $fp = fopen(dirname(__FILE__)."/../../data/payment/log.txt","a");
        flock($fp, LOCK_EX) ;
        fwrite($fp,$word.",Execution date:".strftime("%Y-%m-%d %H:%I:%S",time())."\r\n");
        flock($fp, LOCK_UN);
        fclose($fp);
    }

}//End API