<?php   if(!defined('DEDEINC')) exit('Request Error!');
/**
 * Serialized book called the latest content
 *
 * @version        $Id: bookcontentlist.lib.php 1 9:29 2010-07-06 Z tianya $
 * @package        DedeCMS.Taglib
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */
 
/*>>dede>>
<name>Serialized content</name>
<type>Global tag</type>
<for>V55,V56,V57</for>
<description>Serialized book called the latest content</description>
<demo>
{dede:bookcontentlist row='12' booktype='-1' orderby='lastpost' author='' keyword=''}
<table width="100%" border="0" cellspacing="2" cellpadding="2">
<tr>
<td width='40%'>
[[field:cataloglink/]] [field:booklink/]</td>
<td width='40%'>[field:contentlink/]</td>
<td width='20%'>[field:lastpost function="GetDateMk(@me)"/]</td>
</tr>
</table>
{/dede:bookcontentlist} 
</demo>
<attributes>
    <iterm>row:Call record number</iterm> 
    <iterm>booktype:Book type, 0 books, 1 comic, the default all</iterm>
    <iterm>orderby:Sort type, when the sort type is commend recommendation map书</iterm>
    <iterm>author:Author</iterm>
    <iterm>keyword:Keywords</iterm>
</attributes> 
>>dede>>*/
 
require_once(DEDEINC.'/taglib/booklist.lib.php');

function lib_bookcontentlist(&$ctag, &$refObj)
{
    global $dsql, $envs, $cfg_dbprefix, $cfg_cmsurl;

    $attlist="row|12,booktype|-1,titlelen|30,orderby|lastpost,author|,keyword|";
    FillAttsDefault($ctag->CAttribute->Items,$attlist);
    extract($ctag->CAttribute->Items, EXTR_SKIP);

    if( !$dsql->IsTable("{$cfg_dbprefix}story_books") ) return '没安装连载模块';
    
    return lib_booklist($ctag, $refObj, 1);
    
}