<?php
if(!defined('DEDEINC')) exit('Request Error!');

require_once(DEDEINC.'/channelunit.class.php');

//---------------------------------------
// Html Mark WAP language
//----------------------------------------
function html2wml($content)
{
     //Keep the picture
     preg_match_all("/<img([^>]*)>/isU", $content, $imgarr);
     if(isset($imgarr[0]) && count($imgarr[0])>0 )
     {
         foreach($imgarr[0] as $k=>$v) $content = str_replace($v, "WAP-IMG::{$k}", $content);
     }
     // Filter out style sheets and scripts
     $content = preg_replace("/<style .*?<\/style>/is", "", $content);
     $content = preg_replace("/<script .*?<\/script>/is", "", $content);
     // First of all will be able to cause a newline label（E.g<br />、<p> such as）Replace with newline"\n"
     $content = preg_replace("/<br \s*\/?\/>/i", "\n", $content);
     $content = preg_replace("/<\/?p>/i", "\n", $content);
     $content = preg_replace("/<\/?td>/i", "\n", $content);
     $content = preg_replace("/<\/?div>/i", "\n", $content);
     $content = preg_replace("/<\/?blockquote>/i", "\n", $content);
     $content = preg_replace("/<\/?li>/i", "\n", $content);
     // Replace "& nbsp;" with a space
     $content = preg_replace("/\&nbsp\;/i", " ", $content);
     $content = preg_replace("/\&nbsp/i", " ", $content);
     // Filter the rest of the HTML tags
     $content = strip_tags($content);
     // Transforms the entity in the HTML into the character it corresponds to
     $content = html_entity_decode($content, ENT_QUOTES, "GB2312");
     // Filter out entities that can not be converted（entity）
     $content = preg_replace('/\&\#.*?\;/i', '', $content);
     // The above is the HTML page content is converted into a plain text with a wrap, the following is to convert these plain text into WML.
     $content = str_replace('$', '$$', $content);
     $content = str_replace("\r\n", "\n", dede_htmlspecialchars($content));
     $content = explode("\n", $content);
     for ($i = 0; $i < count($content); $i++)
     {
        $content[$i] = trim($content[$i]);
        // If you remove the full-width spaces for the blank lines, then set to empty lines, or do not filter the full-width spaces.
        if (str_replace('　', '', $content[$i]) == '') $content[$i] = '';
     }
     $content = str_replace("<p><br /></p>\n", "", '<p>'.implode("<br /></p>\n<p>", $content)."<br /></p>\n");
     
     //Restore picture
     if(isset($imgarr[0]) && count($imgarr[0])>0 )
     {
                foreach($imgarr[0] as $k=>$v)
                {
                    $attstr = (preg_match('#/$#', $imgarr[1][$k])) ? '<img '.$imgarr[1][$k].'>' : '<img '.$imgarr[1][$k].' />';
                    $content = str_replace("WAP-IMG::{$k}", $attstr, $content);
                }
     }
     
     $content = preg_replace("/&amp;[a-z]{3,10};/isU", ' ', $content);
     
     return $content;
}

function text2wml($content)
{
     $content = str_replace('$', '$$', $content);
     $content = str_replace("\r\n", "\n", dede_htmlspecialchars($content));
     $content = explode("\n", $content);
     for ($i = 0; $i < count($content); $i++)
     {
        // Filter the first space
        $content[$i] = trim($content[$i]);
        // If you remove the full-width spaces for the blank lines, then set to empty lines, or do not filter the full-width spaces.
        if (str_replace("　", "", $content[$i]) == "") $content[$i] = "";
     }
     //Merge rows, convert to WML, and filter out blank lines
     $content = str_replace("<p><br /></p>\n", "", "<p>".implode("<br /></p>\n<p>", $content)."<br /></p>\n");
     return $content;
}

//----------------------
//GBK characters into UTF8
//----------------------
function ConvertCharset($varlist)
{
    global $cfg_soft_lang;
    if(preg_match('#utf#i',$cfg_soft_lang)) return 0;
    $varlists = explode(',',$varlist);
    $numargs=count($varlists);
    for($i = 0; $i < $numargs; $i++)
    {   
        if(isset($GLOBALS[$varlists[$i]]))
        {
            $GLOBALS[$varlists[$i]] = gb2utf8($GLOBALS[$varlists[$i]]);
        }
    } 
    return 1;
}

//----------------------
//Handling special characters
//----------------------
function ConvertStr($str)
{
    $str = str_replace("&amp;","##amp;",$str);
    $str = str_replace("&","&amp;",$str);
    $str = preg_replace("#[\"><']#","",$str);
    $str = str_replace("##amp;","&amp;",$str);
    return $str;
}

?>
