<?php  if(!defined('DEDEMEMBER')) exit("dedecms");
/**
 * Model list function
 * 
 * @version        $Id: inc_list_functions.php 1 13:52 2010年7月9日Z tianya $
 * @package        DedeCMS.Member
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */

/**
 *  Obtain a recommended statement
 *
 * @param     string  $iscommend  recommend
 * @return    string
 */
function IsCommendArchives($iscommend)
{
    $s = '';
    if(preg_match('/c/', $iscommend))
    {
        $s .= 'recommend';
    }
    else if(preg_match('/h/', $iscommend))
    {
        $s .= ' headlines';
    }
    else if(preg_match('/p/', $iscommend))
    {
        $s .= ' The picture';
    }
    else if(preg_match('/j/', $iscommend))
    {
        $s .= ' jump';
    }
    return $s;
}

/**
 *  Get the recommended title
 *
 * @param     string  $title  The title
 * @param     string  $iscommend  recommend
 * @return    string
 */
function GetCommendTitle($title, $iscommend)
{
    if(preg_match('/c/', $iscommend))
    {
        $title = "$title<font color='red'>(recommended)</font>";
    }
    return "$title";
}

$GLOBALS['RndTrunID'] = 1;
/**
 *  Change the color
 *
 * @param     string  $color1  Color 1
 * @param     string  $color2  2 colors
 * @return    string
 */
function GetColor($color1,$color2)
{
    $GLOBALS['RndTrunID']++;
    if($GLOBALS['RndTrunID']%2==0)
    {
        return $color1;
    }
    else
    {
        return $color2;
    }
}

/**
 *  Check if the image exists
 *
 * @param     string  $picname  Picture address
 * @return    string
 */
function CheckPic($picname)
{
    if($picname!="")
    {
        return $picname;
    }
    else
    {
        return "images/dfpic.gif";
    }
}

/**
 *  Determine whether the content generates HTML
 *
 * @param     int  $ismake  Whether to generate
 * @return    string
 */
function IsHtmlArchives($ismake)
{
    if($ismake==1)
    {
        return "The generated";
    }
    else if($ismake==-1)
    {
        return "Only the dynamic";
    }
    else
    {
        return "<font color='red'>Did not generate</font>";
    }
}

/**
 *  Gets the qualified level name of the content
 *
 * @param     string  $arcrank  Level names
 * @return    string
 */
function GetRankName($arcrank)
{
    global $arcArray;
    if(!is_array($arcArray))
    {
        $dsql->SetQuery("SELECT * FROM #@__arcrank");
        $dsql->Execute();
        while($row = $dsql->GetObject())
        {
            $arcArray[$row->rank]=$row->membername;
        }
    }
    if(isset($arcArray[$arcrank]))
    {
        return $arcArray[$arcrank];
    }
    else
    {
        return "There is no limit";
    }
}

/**
 *  Determine whether the content is a picture article
 *
 * @param     string  $picname  Image name
 * @return    string
 */
function IsPicArchives($picname)
{
    if($picname!="")
    {
        return "<font color='red'>(figure)</font>";
    }
    else
    {
        return "";
    }
}