<?php   if(!defined('DEDEMEMBER')) exit("dedecms");
/**
 * Password function
 * 
 * @version        $Id: inc_pwd_functions.php 1 15:18 2010年7月9日Z tianya $
 * @package        DedeCMS.Member
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */

/**
 *  Verify the code generation function
 *
 * @param     int  $length  The length that needs to be generated
 * @param     int  $numeric  Is it a number
 * @return    string
 */
function random($length, $numeric = 0)
{
    PHP_VERSION < '4.2.0' && mt_srand((double)microtime() * 1000000);
    if($numeric)
    {
        $hash = sprintf('%0'.$length.'d', mt_rand(0, pow(10, $length) - 1));
    }
    else
    {
        $hash = '';
        $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz';
        $max = strlen($chars) - 1;
        for($i = 0; $i < $length; $i++)
        {
            $hash .= $chars[mt_rand(0, $max)];
        }
    }
    return $hash;
}

/**
 *  mails
 *
 * @param     string  $email  The E-mail address
 * @param     string  $mailtitle  E - mail title
 * @param     string  $mailbody  E-mail content
 * @param     string  $headers Header information
 * @return    void
 */
function sendmail($email, $mailtitle, $mailbody, $headers)
{
    global $cfg_sendmail_bysmtp, $cfg_smtp_server, $cfg_smtp_port, $cfg_smtp_usermail, $cfg_smtp_user, $cfg_smtp_password, $cfg_adminemail;
    if($cfg_sendmail_bysmtp == 'Y')
    {
        $mailtype = 'TXT';
        require_once(DEDEINC.'/mail.class.php');
        $smtp = new smtp($cfg_smtp_server,$cfg_smtp_port,true,$cfg_smtp_usermail,$cfg_smtp_password);
        $smtp->debug = false;
        $smtp->sendmail($email,$cfg_webname,$cfg_smtp_usermail, $mailtitle, $mailbody, $mailtype);
    } else {
        @mail($email, $mailtitle, $mailbody, $headers);
    }
}

/**
 *  Send mail; The type is the INSERT new verification code, UPDATE the verification code;
 *
 * @param     int  $mid  The member ID
 * @param     int  $userid  The user ID
 * @param     string  $mailto  Sent to the
 * @param     string  $type  type
 * @param     string  $send  Sent to the
 * @return    string
 */
function newmail($mid, $userid, $mailto, $type, $send)
{
    global $db,$cfg_adminemail,$cfg_webname,$cfg_basehost,$cfg_memberurl;
    $mailtime = time();
    $randval = random(8);
    $mailtitle = $cfg_webname.":Password change";
    $mailto = $mailto;
    $headers = "From: ".$cfg_adminemail."\r\nReply-To: $cfg_adminemail";
    $mailbody = "dear".$userid."：\r\N: hello! Thank you for using".$cfg_webname."Net.\r\n".$cfg_webname."At your request, reset the password: (note: if you do not apply, please check if your information is leaking.）\r\The password for this temporary login is:".$randval." Please log in the following website to confirm the modification within three days.\r\n".$cfg_basehost.$cfg_memberurl."/resetpassword.php?dopost=getpasswd&id=".$mid;
    if($type == 'INSERT')
    {
        $key = md5($randval);
        $sql = "INSERT INTO `#@__pwd_tmp` (`mid` ,`membername` ,`pwd` ,`mailtime`)VALUES ('$mid', '$userid',  '$key', '$mailtime');";
        if($db->ExecuteNoneQuery($sql))
        {
            if($send == 'Y')
            {
                sendmail($mailto,$mailtitle,$mailbody,$headers);
                return ShowMsg('EMAIL modification verification code has been sent to the original mailbox please check', 'login.php','','5000');
            } else if ($send == 'N')
            {
                return ShowMsg('Jump to the change page later', $cfg_basehost.$cfg_memberurl."/resetpassword.php?dopost=getpasswd&amp;id=".$mid."&amp;key=".$randval);
            }
        }
        else
        {
            return ShowMsg('Sorry for the failure, please contact the administrator', 'login.php');
        }
    }
    elseif($type == 'UPDATE')
    {
        $key = md5($randval);
        $sql = "UPDATE `#@__pwd_tmp` SET `pwd` = '$key',mailtime = '$mailtime'  WHERE `mid` ='$mid';";
        if($db->ExecuteNoneQuery($sql))
        {
            if($send == 'Y')
            {
                sendmail($mailto,$mailtitle,$mailbody,$headers);
                ShowMsg('EMAIL modification verification code has been sent to the original mailbox please check', 'login.php');
            }
            elseif($send == 'N')
            {
                return ShowMsg('Jump to the change page later', $cfg_basehost.$cfg_memberurl."/resetpassword.php?dopost=getpasswd&amp;id=".$mid."&amp;key=".$randval);
            }
        }
        else
        {
            ShowMsg('Sorry for the failure, please contact the administrator', 'login.php');
        }
    }
}

/**
 *  Query the mail user to enter E-mail address; Userid user name
 *
 * @param     string  $mail  mail
 * @param     string  $userid  The user ID
 * @return    string
 */
function member($mail, $userid)
{
    global $db;
    $sql = "SELECT mid,email,safequestion FROM #@__member WHERE email='$mail' AND userid = '$userid'";
    $row = $db->GetOne($sql);
    if(!is_array($row)) return ShowMsg("Sorry, user ID input error!","-1");
    else return $row;
}

/**
 *  Check whether the verification code has been sent
 *
 * @param     string  $mid  Member ID
 * @param     string  $userid  user name
 * @param     string  $mailto  Send mail address
 * @param     string  $send  Send mail for Y, Not send mail for N The default is Y.
 * @return    string
 */
function sn($mid,$userid,$mailto, $send = 'Y')
{
    global $db;
    $tptim= (60*10);
    $dtime = time();
    $sql = "SELECT * FROM #@__pwd_tmp WHERE mid = '$mid'";
    $row = $db->GetOne($sql);
    if(!is_array($row))
    {
        //Send new mail
        newmail($mid,$userid,$mailto,'INSERT',$send);
    }
    //After 10 minutes you can send a new verification code again;
    elseif($dtime - $tptim > $row['mailtime'])
    {
        newmail($mid,$userid,$mailto,'UPDATE',$send);
    }
    //Re-send a new verification code confirmation mail;
    else
    {
        return ShowMsg('Sorry, please re-apply after 10 minutes', 'login.php');
    }
}